unit uglobs;

interface

uses
  //comctrls,

  xmatdefs, SysUtils, ucosaConNombre, uActualizadorLPD, ufechas,
  uauxiliares,
  uEstados,
  uCosa,
  Math,
  uconstantesSimSEE,
  umadresuniformes,
  Classes, contnrs,
  uescenarios;

type

  // hasta que  se implemente un calendario, los Domingos son feriados
  // los sbados son semi-feriados y el resto son hbiles
  TTipoDeDia = (DIA_HABIL, DIA_SEMI_FERIADO, DIA_FERIADO);

  TProcNotificacion = procedure;
  TProcAlerta = procedure(const s: string);

  TEstadoDeLaSala = (
    CES_SIN_PREPARAR,
    CES_OPTIMIZANDO,
    CES_OPTIMIZACION_TERMINADA,
    CES_OPTIMIZACION_ABORTADA,
    CES_SIMULANDO,
    CES_SIMULACION_TERMINADA,
    CES_SIMULACION_ABORTADA);


  { TGlobs }

  TGlobs = class(TCosaConNombre)
  private
    procAlertaHabilitado: boolean;
    procAlerta: TProcAlerta;

    fechaIni_old, fechaFin_old: TFecha;

    demandaPrincipal: TCosa; // actor principal de demanda ESTE POSTIZA

  public
    fechaIniOpt, fechaFinOpt: TFecha; // Horizonte de Optimizacin
    fechaIniSim, fechaFinSim: TFecha; // Horizonte de Simulacin
    fechaGuardaSim: TFecha; // Si esta fecha es > fechaIniSim todo lo que pase
    // antes de esta fecha NO se escribe en los archivos de resultados.
    // en particular NO se tienen en cuenta en los calculos para SimCosto.


    NPostes: integer;

    PostesMonotonos: boolean; // TRUE por defecto.
    DurPos, invDurPos: TDAOfNReal; //Duracin en horas de los postes y sus inversos

    SalaMinutal: boolean; // FALSE Horario con durpos.
    // TRUE Minutal en ese caso se usa DurPaso_minutos para
    // definir un nico poste con duracin DurPaso_minutos/60.0  al momento de preparar la Sala.
    DurPaso_minutos: NReal; // Duracin del paso en minutos.


    {$IFDEF CALC_MMEE}
    mmee_TopeDelSpot: NReal;
    mmee_PrecioSpot: TDAOfNReal;
    mmee_SeguimientoDeLaDemanda_USD: TDAOfNReal;
    {$ENDIF}

    // para cada hora del paso tiene el ndice del poste
    // esta clasificacin la hace la Demanda NETA.
    kPosteHorasDelPaso: TDAOfNInt;

    {$IFDEF CALC_DEMANDA_NETA}
    Suma_PHorarias: TDAOfNReal;

    // Tiene la aproximacin entera de las duraciones de los postes.
    NHorasDelPoste: TDAOfNInt;

    // tiene en forma ordenada del poste 1 al ltimo el ndice de las
    // horas que result del postizado del paso. Este es el ndice inverso
    // del mantenido en kPostesHorasDelPaso.
    idxHorasPostizadas: TDAOfNInt;

    // almacena el inicio de cada poste en idxHorasPostizadas
    kBasePosete_idxHorasPostizadas: TDAOfNInt;
    {$ENDIF}

    TasaDeActualizacion: NReal; // tasa de descuento anual
    fActPaso: NReal;

    NCronicasSim: integer; // cantidad de historias a sortear en el simulador
    NCronicasOpt: integer;
    invNCronicasSim, invNCronicasOpt: NReal; //1 / NCronicas...

    //Para reducir el peso de los archivos de resultados de simulacin
    //solo se imprimiran las variables usadas en la plantilla de simres3
    publicarSoloVariablesUsadasEnSimRes3: boolean;

    ActualizadorLPD: TActualizadorFichasLPD;
    abortarSim: boolean;

    // si est a TRUE se agregan en la salida la generacin de los LowCostMustRun
    // y de los NO_LowCostMustRun y la generacin de toneladas de CO2 de cada Grupo.
    Calcular_EmisionesCO2: boolean;
    FactorEmisiones_MargenOperativoTipo: integer;
    // 0: Promedio; 1: Simple; 2: Simple Ajustado
    FactorEmisiones_ProyectoEolicoSolar: boolean;


    // Por defecto a False, si se pone a true, no se consideran las disponibilidades
    ObligarDisponibilidad_1_Sim: boolean;
    ObligarDisponibilidad_1_Opt: boolean;

    // Por defecto a FALSE. Si se marca, se obliga a tratar la disponibilidad de
    // todas las unidades como inciertas al inicio de cada crnica.
    ObligarInicioCronicaIncierto_1_Sim: boolean;

    // esta variable puesta a TRUE obliga la disponibilidad a 1 en SorteosDelPaso
    // La simulacin la debe carcar con ObligarDisponibilidad_1_Sim y la optimizacin
    // la debe cargar ObligarDispnibilidad_1_Opt.
    ObligarDisponibilidad_1_: boolean;


    // especifica si la sala debe ser tratada como determinstica.
    Deterministico: boolean;

    // A True si se activa la consideracin de Reserva Rotante
    flg_ReservaRotante:boolean;


    // parmetros de la iteracin con FlUCAR.
    iteracion_flucar_Archivo_Flucar: string;
    iteracion_flucar_modificar_rendimiento: boolean;
    iteracion_flucar_modificar_capacidad: boolean;
    iteracion_flucar_modificar_peaje: boolean;

    // Por defecto a TRUE, si se pone a FALSE no usa sorteos en la optimizacin y pone
    // los valores esperados de las cosas
    SortearOpt: boolean;

    // Semillas iniciales para Opt y Sim
    semilla_inicial_sim, semilla_inicial_opt: integer;
    NPasos: integer;

    NMAX_ITERACIONESDELPASO_OPT, NMAX_ITERACIONESDELPASO_SIM: integer;

    usar_CAR: boolean; // si est a false optimiza con el criterio clsico de minmizar
    // el valor esperado del costo futuro de operacin.
    NDiscHistoCF: integer;
    // cantidad de puntos usados para el mantenimienot del histograma de Costo Futuro.
    probLimiteRiesgo: NReal; // Probabilidad de Excedencia para clculo de riesgo
    CAR: NReal; // Coeficiente de Aversin al Riesgo. [ 0 , 1 ] Este coeficiente modula entre
    // la minimizacin en valor esperad CAR= 0 y la minimizacin del VaR( probLimiteRiesgo ) si CAR = 1
    // en los valores intermedios se utiliza la combinacin lineal convexa de ambos criterios.

    CAR_CVaR: boolean; // por defecto es true. Si es false usa VaR en lugar de CVaR

    restar_UtilidadesDelCostoFuturo: boolean; // determina


    // variables del simulador
    FechaInicioDelpaso: TFecha;
    FechaFinDelPaso: TFecha;
    kPaso_: integer;

    // variable auxiliar que utilizan las fuentes submuestreadas para
    // saber el subpaso en que estn cuando realizan los sorteosDelPaso
    kSubPaso_: integer;

    //Utilizada por los hilos para saber que vuelta de sorteos del paso
    //estoy realizando sobre el paso en preparar paso ps
    iTareaEjecutando: integer;

    AnioInicioDelPaso: word;
    SemanaInicioDelPaso: word;
    //[1..52] La semana del ao por la que va la simulacion
    HoraDeInicioDelPaso: word;    // [0..23]

    MesInicioDelPaso: word;    //el mes del ao por el que va la simulacin.
    DiaDelMesInicioDelPaso: word;
    DiaDeLaSemanaInicioDelPaso: word;
    DiaDelAnioInicioDelPaso: word;
    HoraDelAnioInicioDelPaso: word;
    FechaInicioDelAnio: TDateTime;
    TipoDeDiaInicioDelPaso: TTipoDeDia;

    dt_DelPaso: NReal; // duracin del paso de tiempo en das punto flontante

    HorasDelPaso: NReal;

    SegundosDelPaso: integer;
    invHorasDelPaso, invSegundosDelPaso: NReal;

    ultimaSemillaFijada: integer;
    // 1 / HorasDelPaso, 1 / SegundosDelPaso
    kCronica: integer;
{$IFDEF ITERAR}
    cntIteracionesDelPaso: integer;
{$ENDIF}

    // Resultado de la optimizacin del paso.
    CostoDelPaso: NReal;

    // Soporte de estados y costos futuros
    CF: TAdminEstados;

    liberarAuxs: boolean;
    Auxs_r0, Auxs_r1: TDAOfDAOfNReal;
    Auxs_i0, Auxs_i1: TDAOfDAOfNInt;

    {$IFDEF PDE_RIESGO}
    HistoCF0: TDAofDAofNReal;
    // Histograma del costo Futuro Al Inicio de la etapa durante OPT
    // La dimensin es NEstrellas x NSorteosOpt x NPuntosHistoCF
    // HistoCF0[ kEstrella ][ kCronOpt * NDiscHistoCF + j ] con j: 0.. NDiscHistoCF - 1

    HistoCF1_: TDAofDAofNReal;
    // Histograma del Costo Futuro al Fin de la etapa durante OPT.
    // La dimsensin es NEstrellas x NPuntosHistoCF
    HistoCF1_s: TDAofDAofNReal; // este es auxiliar para clculo para que no se
    // mezclen en el caso de los multi-hilo
    {$ENDIF}

    // se para que los actores que actualizan el estado se fijen
    // si se debe usar la reduccin de estados auxiliar (si es que tiene)
    CFauxActivo: boolean;

    procNot_InicioSimulacion: TProcNotificacion;
    procNot_InicioCronica: TProcNotificacion;
    procNot_InicioPaso: TProcNotificacion;
    procNot_FinPaso: TProcNotificacion;
    procNot_FinCronica: TProcNotificacion;
    procNot_FinSimulacion: TProcNotificacion;

    procNot_opt_InicioOptimizacion: TProcNotificacion;
    procNot_opt_InicioCronicaSorteos: TProcNotificacion;
    procNot_opt_PrepararPaso_ps: TProcNotificacion;
    procNot_opt_InicioCalculosDeEtapa: TProcNotificacion;
    procNot_opt_FinCalculosDeEtapa: TProcNotificacion;
    procNot_opt_FinCronicaSorteos: TProcNotificacion;
    procNot_opt_FinOptimizacion: TProcNotificacion;

    EstadoDeLaSala: TEstadoDeLaSala;

    MadresUniformes: TMadresUniformes;

    EscenarioActivo: TEscenario_rec; // apunta al de la sala si esta activ un escenario


    //{$IFDEF DBG}
    //      fdbgAbierto: Boolean;
    //      fdbg: TextFile; //Es un archivo que se mantiene abierto durante toda la
    //                      //simulacin para escribirle valores si se desea
    //{$ENDIF}
    constructor Create(nombre: string;
      fechaIniSim, fechaFinSim, fechaGuardaSim: TFecha;
      fechaIniOpt, fechaFinOpt: TFecha; const DurPos: TDAOfNReal); reintroduce;
    constructor Create_ReadFromText(f: TArchiTexto); override;
    procedure WriteToText(f: TArchiTexto); override;
    function calcNPasosSim: integer;
    function calcNPasosOpt: integer;
    function fechaToPasoSim(fecha: TFecha): integer;
    function pasoToFechaSim(paso: integer): TFecha;
    function fechaToPasoOpt(fecha: TFecha): integer;
    function pasoToFechaOpt(paso: integer): TFecha;

    // fija el kPaso, el kSem y el kMes
    procedure Fijar_kPaso(nuevo_kPaso: integer);
    procedure Fijar_FechaInicioDelPaso(fecha: TFecha);
    procedure fijarSemillaAleatoria_(semilla: integer);

    procedure CalcularConstantesBasicasDelPaso;
    procedure Free; override;

    procedure CambioFichaPD; override;
    //Abstracto lanza Excepcion

    // pone todos los procedimientos de notificacin a NIL.
    procedure ClearProcNots;

    // si xproc es <> nil lo ejecuta
    procedure procNot(xproc: TProcNotificacion);
    procedure deshabilitarAlertas;
    procedure habilitarAlertas;
    procedure setProcAlerta(xprocAlerta: TProcAlerta);
    procedure Alerta(const s: string);

    procedure PubliVars; override;

    procedure ClearAuxs1(kIniEstrella, kFinEstrella: integer); // limpia los auxs1
    procedure SwapAuxs;   // conmuta los frames auxilieares 0<->1
    procedure MultAuxs1(mmult: NReal);
    // Los enteros los multiplica y redondea al entero ms proximo

   {$IFDEF CALC_DEMANDA_NETA}
    procedure InicializarNeteadorDeDemanda;
    procedure borrarSumaPHorarias;
    procedure sumarPHoraria(const PHoraria: TDAOfNReal);
    procedure restarPHoraria(const PHoraria: TDAOfNReal);
    procedure postizarPHoraria;
    {$ELSE}
    procedure SetDemandaPrincipal(aDemanda: TCosa);
    function GetDemandaPrincipal: TCosa;
    {$ENDIF}


    class function CreateDataColumnList(xClaseDeCosa:TClaseDeCosa; xVersion: Integer = -2): TDataColumnListOfCosa; override;

    procedure AfterInstantiation; override;

    function Validate():boolean;override;

  end;

function estadoSalaToString(estado: TEstadoDeLaSala): string;

procedure AlInicio;
procedure AlFinal;

implementation

function estadoSalaToString(estado: TEstadoDeLaSala): string;
begin
  case estado of
    CES_SIN_PREPARAR: Result := 'CES_SIN_PREPARAR';
    CES_OPTIMIZANDO: Result := 'CES_OPTIMIZANDO';
    CES_OPTIMIZACION_TERMINADA: Result := 'CES_OPTIMIZACION_TERMINADA';
    CES_OPTIMIZACION_ABORTADA: Result := 'CES_OPTIMIZACION_ABORTADA';
    CES_SIMULANDO: Result := 'CES_SIMULANDO';
    CES_SIMULACION_TERMINADA: Result := 'CES_SIMULACION_TERMINADA';
    CES_SIMULACION_ABORTADA: Result := 'CES_SIMULACION_ABORTADA';
    else
      raise Exception.Create('uglobs.estadoSalaToString, estado desconocido');
  end;
end;

procedure TGlobs.deshabilitarAlertas;
begin
  procAlertaHabilitado := False;
end;

procedure TGlobs.habilitarAlertas;
begin
  procAlertaHabilitado := True;
end;

procedure TGlobs.setProcAlerta(xprocAlerta: TProcAlerta);
begin
  procAlerta := xprocAlerta;
  procAlertaHabilitado := Assigned(xprocAlerta);
end;

procedure TGlobs.Alerta(const s: string);
begin
  if procAlertaHabilitado then
    procAlerta(s);
end;

{$IFDEF CALC_DEMANDA_NETA}
procedure TGlobs.InicializarNeteadorDeDemanda;
var
  iposte: integer;
  nHorasDelPoste_: integer;
  kBasePoste: integer;

begin
  setlength(Suma_PHorarias, max(round(HorasDelPaso), 1 ));
  setlength(idxHorasPostizadas, max( round(HorasDelPaso), 1 ) );
  setlength(kBasePosete_idxHorasPostizadas, NPostes+1 );
  setlength( NHorasDelPoste, NPostes );

  kBasePoste:= 0;
  for iposte := 0 to NPostes - 1 do
  begin
    nHorasDelPoste_ := round(Durpos[iposte]);
    nHorasDelPoste[iposte]:= nHorasDelPoste_;
    kBasePoste:= kBasePoste + nHorasDelPoste_;
    kBasePosete_idxHorasPostizadas[ iposte+1 ]:= kBasePoste;
  end;
end;

procedure TGlobs.borrarSumaPHorarias;
begin
  vclear(Suma_PHorarias);
end;

procedure TGlobs.restarPHoraria(const PHoraria: TDAOfNReal);
var
  k: integer;
begin
  for k := 0 to high(PHoraria) do
    Suma_PHorarias[k] := Suma_PHorarias[k] - PHoraria[k];
end;


procedure TGlobs.sumarPHoraria(const PHoraria: TDAOfNReal);
var
  k: integer;
begin
  for k := 0 to high(PHoraria) do
    Suma_PHorarias[k] := Suma_PHorarias[k] + PHoraria[k];
end;

procedure TGlobs.postizarPHoraria;
var
  k: integer;
  hora, jhora: integer;
  iposte: integer;
begin
  // inicializamos el ndice
  for k := 0 to high(idxHorasPostizadas) do
    idxHorasPostizadas[k] := k;

  if PostesMonotonos then
    QuickSort_Decreciente(Suma_PHorarias, idxHorasPostizadas);

  hora := 0;
  kBasePosete_idxHorasPostizadas[0]:= 0;
  for iposte := 0 to NPostes - 1 do
  begin
    for jhora := 0 to nHorasDelPoste[iposte] - 1 do
    begin
      kPosteHorasDelPaso[idxHorasPostizadas[hora]] := iposte;
      Inc(hora);
    end;
  end;
end;

{$ELSE}


procedure TGlobs.SetDemandaPrincipal(aDemanda: TCosa);
begin
  DemandaPrincipal := aDemanda;
end;

function TGlobs.GetDemandaPrincipal: TCosa;
begin
  Result := DemandaPrincipal;
end;

{$ENDIF}


constructor TGlobs.Create(nombre: string;
  fechaIniSim, fechaFinSim, fechaGuardaSim: TFecha; fechaIniOpt, fechaFinOpt: TFecha;
  const DurPos: TDAOfNReal);
var
  i: integer;
  acumr: NReal;
begin
  inherited Create(0, nombre);
  EscenarioActivo := nil;

  EstadoDeLaSala := CES_SIN_PREPARAR;
  ActualizadorLPD := TActualizadorFichasLPD.Create;
  abortarSim := False;
  self.fechaIniSim := fechaIniSim;
  self.fechaFinSim := fechaFinSim;
  self.fechaGuardaSim := fechaGuardaSim;
  self.fechaIniOpt := fechaIniOpt;
  self.fechaFinOpt := fechaFinOpt;
  Self.NPostes := length(DurPos);
  self.DurPos := copy(DurPos, 0, NPostes);
  SetLength(invDurPos, NPostes);

    {$IFDEF CALC_MMEE}
  mmee_TopeDelSpot := 250.0; // ojo esto es para sobreescribir al leer
  setlength(mmee_PrecioSpot, NPostes);
  setlength(mmee_SeguimientoDeLaDemanda_USD, NPostes);
    {$ENDIF}

  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  acumr := vsum(DurPos);
  dt_DelPaso := acumr / 24.0;
  HorasDelPaso := acumr;
  invHorasDelPaso := 1 / HorasDelPaso;

  setLength(kPosteHorasDelPaso, ceil(HorasDelPaso));
  demandaPrincipal := nil;

  SegundosDelPaso := trunc(HorasDelPaso * 3600 + 0.1);
  invSegundosDelPaso := 1 / SegundosDelPaso;
  FechaInicioDelpaso := TFecha.Create_Clone(fechaIniOpt);
  FechaFinDelPaso := TFecha.Create_OffsetDT(FechaInicioDelpaso, dt_DelPaso);

  PostesMonotonos := True;
  SalaMinutal := False;
  DurPaso_minutos := 10.0;

  SortearOpt := True;
  ObligarDisponibilidad_1_Sim := False;
  ObligarDisponibilidad_1_Opt := False;
  ObligarInicioCronicaIncierto_1_Sim := False;
  Deterministico := False;
  semilla_inicial_sim := 31;
  semilla_inicial_opt := 31;


  CF := nil;
  setlength(Auxs_r0, 0);
  setlength(Auxs_i0, 0);
  setlength(Auxs_r1, 0);
  setlength(Auxs_i1, 0);
  MadresUniformes := TMadresUniformes.Create(10000);

  usar_CAR := False;
  restar_UtilidadesDelCostoFuturo := True;
  NDiscHistoCF := 0;
  probLimiteRiesgo := 0.0;
  CAR := 0.0;
  CAR_CVaR := True;

    {$IFDEF PDE_RIESGO}
  setlength(HistoCF0, 0);
  setlength(HistoCF1_, 0);
  setlength(HistoCF1_s, 0);
    {$ENDIF}

  Fijar_kPaso(1); // solo para que inicialmente est algo definido
  //{$IFDEF DBG}
  //  AssignFile(fdbg, uconstantes.getDir_Dbg + 'debug.txt');
  //  rewrite(fdbg);
  //  fdbgAbierto:= true;
  //{$ENDIF}
  procAlertaHabilitado := False;

{$IFDEF ITERAR}
  NMAX_ITERACIONESDELPASO_OPT := 0;
  NMAX_ITERACIONESDELPASO_SIM := 4;
{$ENDIF}

{$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength( kBasePosete_idxHorasPostizadas, 0 );
  setlength( NHorasDelPoste, 0 );
{$ENDIF}

  publicarSoloVariablesUsadasEnSimRes3:= true;
  flg_ReservaRotante:= false;
end;

procedure TGlobs.Fijar_kPaso(nuevo_kPaso: integer);
begin
  kPaso_ := nuevo_kPaso;
  if EstadoDeLaSala = CES_OPTIMIZANDO then
    FechaInicioDelpaso.PonerIgualAMasOffsetDT(
      fechaIniOpt, dt_DelPaso * (kPaso_ - 1))
  else
    FechaInicioDelpaso.PonerIgualAMasOffsetDT(
      fechaIniSim, dt_DelPaso * (kPaso_ - 1));
  Fijar_FechaInicioDelPaso(FechaInicioDelpaso);
end;

procedure TGlobs.Fijar_FechaInicioDelPaso(fecha: TFecha);
var
  anio: word;
begin
  FechaInicioDelpaso.PonerIgualA(fecha);

//  FechaFinDelPaso.PonerIgualAMasOffsetDT(FechaInicioDelpaso, dt_DelPaso - 1);   //rch@201501222003 ... ??? OJO me parece que el -1 es un bolazo!!!
  FechaFinDelPaso.PonerIgualAMasOffsetDT(FechaInicioDelpaso, dt_DelPaso );
  DecodeDate(FechaInicioDelPaso.dt, anio, mesInicioDelPaso, diaDelMesInicioDelPaso);
  if anio <> anioInicioDelPaso then
  begin
    fechaInicioDelAnio := encodeDate(anio, 1, 1);
    anioInicioDelPaso := anio;
  end;
  //  SemanaInicioDelPaso:= trunc(( FechaInicioDelPaso.dt-fechaInicioDelAnio )/7)+1;
  SemanaInicioDelPaso := trunc((FechaInicioDelPaso.dt - fechaInicioDelAnio) /
    7.038461538) + 1;
  DiaDelAnioInicioDelPaso := trunc(FechaInicioDelPaso.dt - fechaInicioDelAnio) + 1;
  DiaDeLaSemanaInicioDelPaso := DayOfWeek(FechaInicioDelpaso.dt);

  if DiaDeLaSemanaInicioDelPaso = 1 then // domingo
    TipoDeDiaInicioDelPaso := DIA_FERIADO
  else if DiaDeLaSemanaInicioDelPaso = 7 then // sbado
    TipoDeDiaInicioDelPaso := DIA_SEMI_FERIADO
  else
    TipoDeDiaInicioDelPaso := DIA_HABIL;

  if SemanaInicioDelPaso > 52 then
    SemanaInicioDelPaso := 52;

  HoraDeInicioDelPaso := FechaInicioDelPaso.hora;

  HoraDelAnioInicioDelPaso := trunc((FechaInicioDelPaso.dt - FechaInicioDelAnio) * 24);
end;

procedure TGlobs.fijarSemillaAleatoria_(semilla: integer);
begin
  self.ultimaSemillaFijada := semilla;
  MadresUniformes.Reiniciar(semilla);
end;


procedure TGlobs.CalcularConstantesBasicasDelPaso;
var
  acumr: NReal;
begin
  if SalaMinutal then
  begin
    NPostes := 1;
    setlength(DurPos, 1);
    DurPos[0] := DurPaso_minutos / 60.0;
  end;
  acumr := vsum(DurPos);
  dt_DelPaso := acumr / 24.0;
  HorasDelPaso := acumr;
end;

constructor TGlobs.Create_ReadFromText(f: TArchiTexto);
var
  i: integer;
  k_escenario_activo: integer;
begin
  inherited Create_ReadFromText(f);

  {$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength( kBasePosete_idxHorasPostizadas, 0 );
  setlength( NHorasDelPoste, 0 );
{$ENDIF}

  EscenarioActivo := nil;

  Calcular_EmisionesCO2 := False;
  restar_UtilidadesDelCostoFuturo := False;

  //iteracion_flucar_Archivo_Flucar:= '';
  iteracion_flucar_modificar_rendimiento := True;
  iteracion_flucar_modificar_capacidad := True;
  iteracion_flucar_modificar_peaje := False;

  FactorEmisiones_MargenOperativoTipo := 0;
  FactorEmisiones_ProyectoEolicoSolar := True;
  CAR_CVaR := True;

  ObligarInicioCronicaIncierto_1_Sim := False;

  fechaGuardaSim := nil;

  SalaMinutal := False;
  DurPaso_minutos := 10.0;

  if f.Version < 25 then
  begin
    fechaIni_old := nil;
    fechaFin_old := nil;
    fechaIniSim := nil;
    fechaFinSim := nil;
    fechaIniOpt := nil;
    fechaFinOpt := nil;

    f.IniciarLecturaRetrasada;
    f.rd('NPostes', NPostes);

    f.rd('fechaIni', fechaIni_old, 1);
    f.rd('fechaFin', fechaFin_old, 1);

    f.rd('fechaIniSim', fechaIniSim, 1);
    f.rd('fechaFinSim', fechaFinSim, 1);
    f.rd('fechaIniOpt', fechaIniOpt, 1);
    f.rd('fechaFinOpt', fechaFinOpt, 1);

    f.rd('durpos', durpos);
    f.rd('tasaDeActualizacion', tasaDeActualizacion);
    f.rd('NCronicasSim', NCronicasSim);
    f.rd('NCronicasOpt', NCronicasOpt);
    f.rd('ObligarDisponibilidad_1', ObligarDisponibilidad_1_Sim);

    ObligarDisponibilidad_1_Opt := False;
    Deterministico := False;
    f.rd('SortearOpt', SortearOpt);
    f.rd('PostesMonotonos', PostesMonotonos);

    f.EjecutarLectura;

    if (fechaIniSim = nil) or (fechaIniSim.dt = 0) then
      fechaIniSim := fechaIni_old;
    if (fechaFinSim = nil) or (fechaFinSim.dt = 0) then
      fechaFinSim := fechaFin_old;

    if (fechaIniOpt = nil) or (fechaIniOpt.dt = 0) then
      fechaIniOpt := fechaIni_old;
    if (fechaFinOpt = nil) or (fechaFinOpt.dt = 0) then
      fechaFinOpt := fechaFin_old;

    NMAX_ITERACIONESDELPASO_OPT := 0;
    NMAX_ITERACIONESDELPASO_SIM := 4;

    usar_CAR := False;
    NDiscHistoCF := 0;
    probLimiteRiesgo := 0.0;
    CAR := 0.0;

    //{$IFDEF DBG}
    //  AssignFile(fdbg, uconstantes.getDir_Dbg + 'debug.txt');
    //  rewrite(fdbg);
    //{$ENDIF}
    procAlertaHabilitado := False;
  end
  else
  begin
    fechaIni_old := nil;
    fechaFin_old := nil;
    fechaIniSim := nil;
    fechaFinSim := nil;
    fechaIniOpt := nil;
    fechaFinOpt := nil;

    f.IniciarLecturaRetrasada;
    f.rd('NPostes', NPostes);


    f.rd('fechaIni', fechaIni_old, 1);
    f.rd('fechaFin', fechaFin_old, 1);
    f.rd('fechaIniSim', fechaIniSim, 1);
    f.rd('fechaFinSim', fechaFinSim, 1);
    if (f.Version >= 102) then
      f.rd('fechaGuardaSim', fechaGuardaSim)
    else
      fechaGuardaSim := TFecha.Create_Dt(0);

    f.rd('fechaIniOpt', fechaIniOpt, 1);
    f.rd('fechaFinOpt', fechaFinOpt, 1);

    f.rd('durpos', durpos);

    if f.Version >= 104 then
    begin
      f.rd('SalaMinutal', SalaMinutal);
      f.rd('DurPaso_minutos', DurPaso_minutos);
    end;

    f.rd('tasaDeActualizacion', tasaDeActualizacion);
    f.rd('NCronicasSim', NCronicasSim);
    f.rd('NCronicasOpt', NCronicasOpt);

    if f.Version >= 99 then
    begin
      f.rd('semilla_inicial_sim', semilla_inicial_sim);
      f.rd('semilla_inicial_opt', semilla_inicial_opt);
    end
    else
    begin
      semilla_inicial_sim := 31;
      semilla_inicial_opt := 31;
    end;

    if f.version < 87 then
    begin
      f.rd('ObligarDisponibilidad_1', ObligarDisponibilidad_1_Sim);
      ObligarDisponibilidad_1_Opt := False;
    end
    else
    begin
      f.rd('ObligarDisponibilidad_1_Sim', ObligarDisponibilidad_1_Sim);
      f.rd('ObligarDisponibilidad_1_Opt', ObligarDisponibilidad_1_Opt);
    end;

    if f.Version >= 101 then
      f.rd('ObligarInicioCronicaIncierto_1_Sim', ObligarInicioCronicaIncierto_1_Sim);


    if f.version < 88 then
      Deterministico := False
    else
      f.rd('Deterministico', Deterministico);

    f.rd('SortearOpt', SortearOpt);
    f.rd('PostesMonotonos', PostesMonotonos);
    f.rd('NMAX_ITERACIONESDELPASO_OPT', NMAX_ITERACIONESDELPASO_OPT);
    f.rd('NMAX_ITERACIONESDELPASO_SIM', NMAX_ITERACIONESDELPASO_SIM);


    if f.Version < 59 then
    begin
      usar_CAR := False;
      NDiscHistoCF := 0;
      probLimiteRiesgo := 0.0;
      CAR := 0.0;
    end
    else
    begin
      f.rd('usar_CAR', usar_CAR);
      f.rd('NDiscHistoCF', NDiscHistoCF);
      f.rd('probLimiteRiesgo', probLimiteRiesgo);
      f.rd('CAR', CAR);
    end;

    if f.Version >= 97 then
      f.rd('CAR_CVaR', self.CAR_CVaR);


    if f.Version >= 63 then
      f.rd('Calcular_EmisionesCO2', Calcular_EmisionesCO2);

    if f.Version >= 68 then
    begin
      f.rd('FactorEmisiones_MargenOperativoTipo', FactorEmisiones_MargenOperativoTipo);
      f.rd('FactorEmisiones_ProyectoEolicoSolar', FactorEmisiones_ProyectoEolicoSolar);
    end;

    if f.Version >= 74 then
    begin
      f.rd('iteracion_flucar_Archivo_Flucar', iteracion_flucar_Archivo_Flucar);
      f.rd('iteracion_flucar_modificar_rendimiento',
        iteracion_flucar_modificar_rendimiento);
      f.rd('iteracion_flucar_modificar_capacidad',
        iteracion_flucar_modificar_capacidad);
      f.rd('iteracion_flucar_modificar_peaje', iteracion_flucar_modificar_peaje);
    end;

    if f.Version >= 84 then
    begin
      f.rd('RestarUtilidadesDelCostoFuturo', restar_UtilidadesDelCostoFuturo);
    end;

    if f.version > 108 then
      f.rd('publicarSoloVariablesUsadasEnSimRes3',
        publicarSoloVariablesUsadasEnSimRes3)
    else
      publicarSoloVariablesUsadasEnSimRes3 := False;

    if f.Version > 130 then
      f.rd('flg_ReservaRotante', flg_ReservaRotante )
    else
      flg_ReservaRotante:= false;

    {$IFDEF PDE_RIESGO}
    setlength(HistoCF0, 0);
    setlength(HistoCF1_, 0);
    setlength(HistoCF1_s, 0);
    {$ENDIF}

    f.EjecutarLectura;

    if (fechaIniSim = nil) or (fechaIniSim.dt = 0) then
      fechaIniSim := fechaIni_old;
    if (fechaFinSim = nil) or (fechaFinSim.dt = 0) then
      fechaFinSim := fechaFin_old;

    if (fechaIniOpt = nil) or (fechaIniOpt.dt = 0) then
      fechaIniOpt := fechaIni_old;
    if (fechaFinOpt = nil) or (fechaFinOpt.dt = 0) then
      fechaFinOpt := fechaFin_old;

    //{$IFDEF DBG}
    //  AssignFile(fdbg, uconstantes.getDir_Dbg + 'debug.txt');
    //  rewrite(fdbg);
    //{$ENDIF}
    procAlertaHabilitado := False;

  end;

  calcularConstantesBasicasDelPaso;


  setLength(kPosteHorasDelPaso, ceil(HorasDelPaso));
  demandaPrincipal := nil;

    {$IFDEF CALC_MMEE}
  mmee_TopeDelSpot := 250.0; // ojo esto es para sobreescribir al leer
  setlength(mmee_PrecioSpot, NPostes);
  setlength(mmee_SeguimientoDeLaDemanda_USD, NPostes);
    {$ENDIF}



  SetLength(invDurPos, length(DurPos));
  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  invHorasDelPaso := 1 / HorasDelPaso;
  SegundosDelPaso := trunc(HorasDelPaso * 3600 + 0.1);
  invSegundosDelPaso := 1 / SegundosDelPaso;
  EstadoDeLaSala := CES_SIN_PREPARAR;
  ActualizadorLPD := TActualizadorFichasLPD.Create;
  FechaInicioDelpaso := TFecha.Create_Clone(fechaIniOpt);
  FechaFinDelPaso := TFecha.Create_OffsetHoras(FechaInicioDelpaso, HorasDelPaso);
  CF := nil;
  clearProcNots;
  MadresUniformes := TMadresUniformes.Create(10000);
  Fijar_kPaso(1); // solo para que inicialmente est algo definido
end;

procedure TGlobs.ClearProcNots;
begin
  procNot_InicioSimulacion := nil;
  procNot_InicioCronica := nil;
  procNot_InicioPaso := nil;
  procNot_FinPaso := nil;
  procNot_FinCronica := nil;
  procNot_FinSimulacion := nil;

  procNot_opt_InicioOptimizacion := nil;
  procNot_opt_InicioCalculosDeEtapa := nil;
  procNot_opt_InicioCronicaSorteos := nil;
  procNot_opt_PrepararPaso_ps := nil;
  procNot_opt_FinCronicaSorteos := nil;
  procNot_opt_FinCalculosDeEtapa := nil;
  procNot_opt_FinOptimizacion := nil;

  procAlerta := nil;
  procAlertaHabilitado := False;
end;

procedure TGlobs.procNot(xproc: TProcNotificacion);
begin
  if assigned(xproc) then
    xproc;
end;

procedure TGlobs.WriteToText(f: TArchiTexto);
begin
  inherited WriteToText(f);
  f.wr('NPostes', NPostes);
  f.wr('fechaIniSim', fechaIniSim);
  f.wr('fechaFinSim', fechaFinSim);
  f.wr('fechaGuardaSim', fechaGuardaSim);
  f.wr('fechaIniOpt', fechaIniOpt);
  f.wr('fechaFinOpt', fechaFinOpt);
  f.wr('durpos', durpos, 8, 2);
  f.wr('SalaMinutal', SalaMinutal);
  f.wr('DurPaso_minutos', DurPaso_minutos);
  f.wr('tasaDeActualizacion', tasaDeActualizacion, 8, 3);
  f.wr('NCronicasSim', NCronicasSim);
  f.wr('NCronicasOpt', NCronicasOpt);
  f.wr('semilla_inicial_sim', semilla_inicial_sim);
  f.wr('semilla_inicial_opt', semilla_inicial_opt);
  f.wr('ObligarDisponibilidad_1_Sim', ObligarDisponibilidad_1_Sim);
  f.wr('ObligarDisponibilidad_1_Opt', ObligarDisponibilidad_1_Opt);
  f.wr('ObligarInicioCronicaIncierto_1_Sim', ObligarInicioCronicaIncierto_1_Sim);
  f.wr('Deterministico', Deterministico);
  f.wr('SortearOpt', SortearOpt);
  f.wr('PostesMonotonos', PostesMonotonos);
  f.wr('NMAX_ITERACIONESDELPASO_OPT', NMAX_ITERACIONESDELPASO_OPT);
  f.wr('NMAX_ITERACIONESDELPASO_SIM', NMAX_ITERACIONESDELPASO_SIM);
  f.wr('usar_CAR', usar_CAR);
  f.wr('NDiscHistoCF', NDiscHistoCF);
  f.wr('probLimiteRiesgo', probLimiteRiesgo);
  f.wr('CAR', CAR);
  f.wr('CAR_CVaR', self.CAR_CVaR);
  f.wr('Calcular_EmisionesCO2', Calcular_EmisionesCO2);
  f.wr('FactorEmisiones_MargenOperativoTipo', FactorEmisiones_MargenOperativoTipo);
  f.wr('FactorEmisiones_ProyectoEolicoSolar', FactorEmisiones_ProyectoEolicoSolar);
  f.wr('iteracion_flucar_Archivo_Flucar', iteracion_flucar_Archivo_Flucar);
  f.wr('iteracion_flucar_modificar_rendimiento',
    iteracion_flucar_modificar_rendimiento);
  f.wr('iteracion_flucar_modificar_capacidad', iteracion_flucar_modificar_capacidad);
  f.wr('iteracion_flucar_modificar_peaje', iteracion_flucar_modificar_peaje);
  f.wr('RestarUtilidadesDelCostoFuturo', restar_UtilidadesDelCostoFuturo);
  f.wr('publicarSoloVariablesUsadasEnSimRes3', publicarSoloVariablesUsadasEnSimRes3);
  f.wr('flg_ReservaRotante', flg_ReservaRotante );
end;

function TGlobs.calcNPasosSim: integer;
var
  rn: NReal;
begin
  rn := (fechaFinSim.dt - fechaIniSim.dt) / dt_DelPaso;
  Result := trunc(rn);
end;

function TGlobs.calcNPasosOpt: integer;
begin
  Result := trunc((fechaFinOpt.dt - fechaIniOpt.dt) / dt_DelPaso);

end;

//Retorna el paso de la simulacin comenzando de 1
function TGlobs.fechaToPasoSim(fecha: TFecha): integer;
begin
  Result := trunc((fecha.dt - fechaIniSim.dt) / dt_DelPaso) + 1;
end;

function TGlobs.pasoToFechaSim(paso: integer): TFecha;
begin
  Result := TFecha.Create_Dt(fechaIniSim.dt + (paso - 1) * dt_DelPaso);
end;

function TGlobs.fechaToPasoOpt(fecha: TFecha): integer;
begin
  Result := trunc((fecha.dt - fechaIniOpt.dt) / dt_DelPaso) + 1;
end;

function TGlobs.pasoToFechaOpt(paso: integer): TFecha;
begin
  Result := TFecha.Create_Dt(fechaIniOpt.dt + (paso - 1) * dt_DelPaso);
end;


procedure TGlobs.ClearAuxs1(kIniEstrella, kFinEstrella: integer); // limpia los auxs1
var
  k: integer;
begin
  for k := 0 to high(Auxs_r1) do
    vclear(Auxs_r1[k], kIniEstrella, kFinEstrella);
  for k := 0 to high(Auxs_i1) do
    vclear(Auxs_i1[k], kIniEstrella, kFinEstrella);
end;

procedure TGlobs.MultAuxs1(mmult: NReal);
var
  k: integer;
begin
  for k := 0 to high(Auxs_r1) do
    vmultr(Auxs_r1[k], mmult);
  for k := 0 to high(Auxs_i1) do
    vmultr(Auxs_i1[k], mmult);
end;

procedure TGlobs.SwapAuxs; // conmuta los frames auxilieares 0<->1
var
  tvr: TDAOfDAOfNReal;
  tvi: TDAOfDAOFNint;
begin
  tvr := Auxs_r0;
  Auxs_r0 := Auxs_r1;
  Auxs_r1 := tvr;

  tvi := Auxs_i0;
  Auxs_i0 := Auxs_i1;
  Auxs_i1 := tvi;

  {$IFDEF PDE_RIESGO}
  tvr := HistoCF1_;
  HistoCF1_ := HistoCF1_s;
  HistoCF1_s := tvr;
  {$ENDIF}
end;

procedure TGlobs.Free;
var
  k: integer;
begin
  setlength(DurPos, 0);
  SetLength(invDurPos, 0);

  {$IFDEF CALC_MMEE}
  setlength(mmee_PrecioSpot, 0);
  setlength(mmee_SeguimientoDeLaDemanda_USD, 0);
  {$ENDIF}

  ActualizadorLPD.Free;
  if FechaInicioDelpaso <> nil then
    FechaInicioDelPaso.Free;
  if FechaFinDelPaso <> nil then
    FechaFinDelPaso.Free;

  if CF <> nil then
    CF.Free;

  if liberarAuxs then
  begin
    for k := 0 to high(Auxs_r0) do
    begin
      setlength(Auxs_r0[k], 0);
      setlength(Auxs_r1[k], 0);
    end;
    setlength(Auxs_r0, 0);
    setlength(Auxs_r1, 0);

    for k := 0 to high(Auxs_i0) do
    begin
      setlength(Auxs_i0[k], 0);
      setlength(Auxs_i1[k], 0);
    end;
    setlength(Auxs_i0, 0);
    setlength(Auxs_i1, 0);
  end;


  {$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength( kBasePosete_idxHorasPostizadas, 0 );
  setlength( NHorasDelPoste, 0 );
  {$ENDIF}


  //{$IFDEF DBG}
  //  CloseFile(fdbg);
  //{$ENDIF}
  inherited Free;
end;

procedure TGlobs.CambioFichaPD;
begin
  raise Exception.Create('Metodo abstracto cambioFichaPD en ' + self.ClassName);
end;

procedure TGlobs.PubliVars;
begin
  inherited PubliVars;
  PublicarVariableFecha('FechaInicioDelPaso', FechaInicioDelPaso);
  PublicarVariableFecha('FechaFinDelPaso', FechaFinDelPaso);
  PublicarVariableNI('kPaso', '-', kPaso_);
  PublicarVariableNI('kCronica', '-', kCronica);
end;


class function TGlobs.CreateDataColumnList(xClaseDeCosa: TClaseDeCosa;
  xVersion: Integer): TDataColumnListOfCosa;
var
  list: TDataColumnListOfCosa;
  //revl: TListRegularExpressionValidator;
begin
  //list:= TDataColumnListOfCosa.Create(TGlobs, xVersion);
  //list.AddList(inherited CreateDataColumnList(xVersion));
  list:=inherited CreateDataColumnList(xClaseDeCosa, xVersion);
  list.AddDataColumn('Calcular_EmisionesCO2', TGlobs(nil).Calcular_EmisionesCO2, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('CAR', TGlobs(nil).CAR, TDataTypeDoubleOfCosa, 113, -1);
  list.AddDataColumn('CAR_CVaR', TGlobs(nil).CAR_CVaR, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('Deterministico', TGlobs(nil).Deterministico, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('NPostes', TGlobs(nil).NPostes, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('DurPos', TGlobs(nil).DurPos, TDataTypeDAOfDoubleOfCosa, 113, -1);
  list.AddDataColumn('DurPaso_minutos', TGlobs(nil).DurPaso_minutos, TDataTypeDoubleOfCosa, 113, -1);
  list.AddDataColumn('FactorEmisiones_MargenOperativoTipo', TGlobs(nil).FactorEmisiones_MargenOperativoTipo, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('FactorEmisiones_ProyectoEolicoSolar', TGlobs(nil).FactorEmisiones_ProyectoEolicoSolar, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('fechaFinOpt', TGlobs(nil).fechaFinOpt, TDataTypeDateOfCosa, 113, -1);
  list.AddDataColumn('fechaFinSim', TGlobs(nil).fechaFinSim, TDataTypeDateOfCosa, 113, -1);
  list.AddDataColumn('fechaGuardaSim', TGlobs(nil).fechaGuardaSim, TDataTypeDateOfCosa, 113, -1);
  list.AddDataColumn('fechaIniOpt', TGlobs(nil).fechaIniOpt, TDataTypeDateOfCosa, 113, -1);
  list.AddDataColumn('fechaIniSim', TGlobs(nil).fechaIniSim, TDataTypeDateOfCosa, 113, -1);
  list.AddDataColumn('iteracion_flucar_Archivo_Flucar', TGlobs(nil).iteracion_flucar_Archivo_Flucar, TDataTypeStringOfCosa, 113, -1);
  list.AddDataColumn('iteracion_flucar_modificar_peaje', TGlobs(nil).iteracion_flucar_modificar_peaje, TDataTypeBooleanOfCosa, ['', '0'], 113, -1);
  list.AddDataColumn('iteracion_flucar_modificar_rendimiento', TGlobs(nil).iteracion_flucar_modificar_rendimiento, TDataTypeBooleanOfCosa, ['', '0'], 113, -1);
  list.AddDataColumn('iteracion_flucar_modificar_capacidad', TGlobs(nil).iteracion_flucar_modificar_capacidad, TDataTypeBooleanOfCosa, ['', '0'], 113, -1);
  list.AddDataColumn('NCronicasOpt',TGlobs(nil).NCronicasOpt,TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('NCronicasSim', TGlobs(nil).NCronicasSim, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('NDiscHistoCF', TGlobs(nil).NDiscHistoCF, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('NMAX_ITERACIONESDELPASO_OPT', TGlobs(nil).NMAX_ITERACIONESDELPASO_OPT, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('NMAX_ITERACIONESDELPASO_SIM', TGlobs(nil).NMAX_ITERACIONESDELPASO_SIM, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('ObligarDisponibilidad_1_Opt', TGlobs(nil).ObligarDisponibilidad_1_Opt, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('ObligarDisponibilidad_1_Sim', TGlobs(nil).ObligarDisponibilidad_1_Sim, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('ObligarInicioCronicaIncierto_1_Sim', TGlobs(nil).ObligarInicioCronicaIncierto_1_Sim, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('PostesMonotonos', TGlobs(nil).PostesMonotonos, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('probLimiteRiesgo', TGlobs(nil).probLimiteRiesgo, TDataTypeDoubleOfCosa, 113, -1);
  list.AddDataColumn('publicarSoloVariablesUsadasEnSimRes3', TGlobs(nil).publicarSoloVariablesUsadasEnSimRes3, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('restarUtilidadesDelCostoFuturo', TGlobs(nil).restar_UtilidadesDelCostoFuturo, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('SalaMinutal', TGlobs(nil).SalaMinutal, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('semilla_inicial_opt', TGlobs(nil).semilla_inicial_opt, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('semilla_inicial_sim', TGlobs(nil).semilla_inicial_sim, TDataTypeIntegerOfCosa, 113, -1);
  list.AddDataColumn('SortearOpt', TGlobs(nil).SortearOpt, TDataTypeBooleanOfCosa, 113, -1);
  list.AddDataColumn('TasaDeActualizacion', TGlobs(nil).TasaDeActualizacion, TDataTypeDoubleOfCosa, 113, -1);
  list.AddDataColumn('usar_CAR', TGlobs(nil).usar_CAR, TDataTypeBooleanOfCosa, 113, -1);


  list.ValidationList.Add(TValidation.Create(TOperator.LESS_OR_EQUAL,'fechaIniOpt','fechaIniSim','El valor de fechaIniOpt debe ser menor o igual al de fechaIniSim.'));
  list.ValidationList.Add(TValidation.Create(TOperator.LESS_OR_EQUAL,'fechaIniSim','fechaFinSim','El valor de fechaIniSim debe ser menor o igual al de fechaFinSim.'));
  list.ValidationList.Add(TValidation.Create(TOperator.LESS_OR_EQUAL,'fechaFinSim','fechaFinOpt','El valor de fechaFinSim debe ser menor o igual al de fechaFinOpt.'));

  list.ValidationList.Add(TValidation.Create(TOperator.REGEX,'EtAct','^[0-9]+\d{0,9999}$','El valor para el campo EtAct debe estar entre 0 y 9999.'));
  list.ValidationList.Add(TValidation.Create(TOperator.REGEX,'eMaxNItersOpt','^[0-9]+\d{0,9999}$','El valor para el campo eMaxNItersOpt debe estar entre 0 y 9999.'));
  list.ValidationList.Add(TValidation.Create(TOperator.REGEX,'eMaxNItersSim','^[0-9]+\d{0,9999}$','El valor para el campo eMaxNItersSim debe estar entre 0 y 9999.'));

  list.ValidationList.Add(TValidation.Create(TOperator.REGEX,'IntNPostes','^[1-9]+\d{1,9999}$','El valor para el campo IntNPostes debe estar entre 1 y 9999.'));
  list.ValidationList.Add(TValidation.Create(TOperator.REGEX,'NCronicasOpt','^[1-9]+\d{1,9999}$','El valor para el campo ENCronicasOpt debe estar entre 1 y 9999.'));
  list.ValidationList.Add(TValidation.Create(TOperator.REGEX,'NCronicasSim','^[1-9]+\d{1,9999}$','El valor para el campo ENCronicasSim debe estar entre 1 y 9999.'));
  list.AddDataColumn('flg_ReservaRotante', TGlobs(nil).flg_ReservaRotante, TDataTypeBooleanOfCosa, 131, -1);


  Result:=list;
end;

procedure TGlobs.AfterInstantiation;
var
  i: Integer;
begin
  inherited AfterInstantiation;
{$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength( kBasePosete_idxHorasPostizadas, 0 );
  setlength( NHorasDelPoste, 0 );
{$ENDIF}
  EscenarioActivo := nil;
{$IFDEF PDE_RIESGO}
  setlength(HistoCF0, 0);
  setlength(HistoCF1_, 0);
  setlength(HistoCF1_s, 0);
{$ENDIF}
  procAlertaHabilitado := False;
  calcularConstantesBasicasDelPaso;

  setLength(kPosteHorasDelPaso, ceil(HorasDelPaso));
  demandaPrincipal := nil;
{$IFDEF CALC_MMEE}
  mmee_TopeDelSpot := 250.0; // ojo esto es para sobreescribir al leer
  setlength(mmee_PrecioSpot, NPostes);
  setlength(mmee_SeguimientoDeLaDemanda_USD, NPostes);
{$ENDIF}
  SetLength(invDurPos, length(DurPos));

  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  SetLength(invDurPos, length(DurPos));

  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  invHorasDelPaso := 1 / HorasDelPaso;
  SegundosDelPaso := trunc(HorasDelPaso * 3600 + 0.1);
  invSegundosDelPaso := 1 / SegundosDelPaso;
  EstadoDeLaSala := CES_SIN_PREPARAR;
  ActualizadorLPD := TActualizadorFichasLPD.Create;
  FechaInicioDelpaso := TFecha.Create_Clone(fechaIniOpt);
  FechaFinDelPaso := TFecha.Create_OffsetHoras(FechaInicioDelpaso, HorasDelPaso);
  CF := nil;
  clearProcNots;
  MadresUniformes := TMadresUniformes.Create(10000);
  Fijar_kPaso(1); // solo para que inicialmente est algo definido

end;

function TGlobs.Validate: boolean;
var
  isValid:boolean;
begin
  isValid:=false;

  // fIniOpt <= fIniSim <= fFinSim <= fFinOpt
  if (self.FechaIniOpt.dt <= self.FechaIniSim.dt) and
     (self.FechaIniSim.dt <= self.FechaFinSim.dt) and
     (self.FechaFinSim.dt <= self.FechaFinOpt.dt) then
    isValid:=true;

  Result:=(inherited Validate) and isValid;
end;


procedure AlInicio;
begin
  registrarClaseDeCosa(TGlobs.ClassName, TGlobs);
end;

procedure AlFinal;
begin
end;

end.


